import { EventHandlerType, EventSourceParametersType } from './types';
export interface IEventSource {
    readonly isOpen: boolean;
    open: (onEvent: EventHandlerType) => void;
    close: () => void;
    onError: (callback: (error: Event) => void) => void;
}
export declare class KameleoonEventSource implements IEventSource {
    private eventSource;
    private siteCode;
    private url;
    private isConnectionOpen;
    constructor({ siteCode, externalEventSource, urlProvider, }: EventSourceParametersType);
    get isOpen(): boolean;
    open(onEvent: EventHandlerType): void;
    close(): void;
    onError(callback: (error: Event) => void): void;
    private handleMessage;
}
