import { CookieDataType, CookieType, IKameleoonData } from './types';
import { TrackingStatus } from '../types';
/**
 * @class
 * Cookie - a class for creating an instance for defining user's cookie
 * */
export declare class Cookie implements IKameleoonData {
    status: TrackingStatus;
    private cookie;
    /**
     * @param {CookieType[]} cookie - a list of cookies
     * */
    constructor(cookie: CookieType[]);
    /**
     * @method fromString - a static method for creating an instance of `Cookie` from a string
     * @param {string} cookieString - a string containing a list of cookies
     * @throws {KameleoonError} throws an error if the string is not valid cookie
     * @returns {Cookie} an instance of `Cookie`
     * */
    static fromString(cookieString: string): Cookie;
    get url(): string;
    get data(): CookieDataType;
}
