import { TrackingStatus } from '../types';
import { IKameleoonData, PersonalizationDataType } from './types';
import { VisitType } from '../requester';
export declare class Personalization implements IKameleoonData {
    status: TrackingStatus;
    private readonly id;
    private readonly variationId;
    /**
     * @param {number} id
     * @param {number} variationId
     * */
    constructor(id: number, variationId: number);
    get url(): string;
    get data(): PersonalizationDataType;
    /**
     * @private
     * @method _fromRaw - an internal method for creating a Personalization instance from raw data
     * @param {PersonalizationDataType} data - a raw data
     * @return {Personalization} a Personalization instance
     * */
    static _fromRaw(data: PersonalizationDataType): Personalization;
    /**
     * @private
     * @method _updateFromVisit - an internal method for updating a list of Personalization instances
     * @param {VisitType} visit - a visits
     * @param {Map<number, Personalization>} dataMap - a map of Personalization instances
     * */
    static _updateFromVisit(visit: VisitType, dataMap: Map<number, Personalization>): void;
}
