import { TrackingStatus } from '../types';
import { IKameleoonData, IdentifierDataType } from './types';
export declare class UniqueIdentifier implements IKameleoonData {
    status: TrackingStatus;
    private _value;
    /**
     * @param {boolean} value - a boolean value that indicates if the visitor has a unique identifier
     * */
    constructor(value: boolean);
    get url(): string;
    get data(): IdentifierDataType;
    /**
     * @private
     * @method _fromRaw - an internal method for creating a UniqueIdentifier instance from raw data
     * @param {IdentifierDataType} data - a raw data
     * @return {UniqueIdentifier} a UniqueIdentifier instance
     * */
    static _fromRaw(data: IdentifierDataType): UniqueIdentifier;
}
