import { VisitType } from '../requester';
import { VisitProcessorDataType, KCSType, VisitorProcessorParametersType, CBSType } from './types';
import { MappingIdentifierType } from '../storage/types';
interface IVisitProcessor {
    processVisit(visit: VisitType): void;
    processKcs(kcsData?: KCSType): void;
    processCbs(cbsData?: CBSType): void;
    processMultipleDataTypes(): void;
    processMappingIdentifier(visit?: VisitType): MappingIdentifierType | undefined;
    processVisitsData(visit: VisitType): void;
}
export declare class VisitProcessor implements IVisitProcessor {
    private visitsData;
    private visitorData;
    private storageVisitorData;
    private experimentData;
    private filters;
    private visitorDataTypes;
    private dataManager;
    private singleDataTypes;
    private multipleDataTypes;
    constructor({ filters, dataManager, visitorCode, }: VisitorProcessorParametersType);
    get data(): VisitProcessorDataType;
    processVisit(visit: VisitType): void;
    processMultipleDataTypes(): void;
    processKcs(kcsData?: KCSType): void;
    processVisitsData(visit: VisitType): void;
    processCbs(cbsData?: CBSType): void;
    private processBrowser;
    private processDevice;
    private processOperatingSystem;
    private processGeolocationData;
    private processCustomData;
    private processConversion;
    private processPageView;
    private processExperiments;
    private processPersonalization;
    processMappingIdentifier(visit?: VisitType): MappingIdentifierType | undefined;
}
export {};
