import { IKameleoonData, VisitsDataType } from './types';
import { TrackingStatus } from '../types';
/**
 * @class
 * Visits - a class for creating an instance of a stored visits data
 * */
export declare class VisitsData implements IKameleoonData {
    private visits;
    status: TrackingStatus;
    /**
     * @param {number[]} visits - a list of visits
     * */
    constructor(visits: number[]);
    get url(): string;
    get data(): VisitsDataType;
    get isSent(): boolean;
    /**
     * Adds a single timestamp while ensuring the list remains sorted and unique
     * @param {number} timestamp - The timestamp to add
     */
    set timestamp(timestamp: number);
}
