import { KameleoonStorageKey } from '../storage';
import { TargetingType } from '../targeting';
export declare const ERROR_MESSAGES: {
    CookieParse: (reason: string) => string;
    JSONParse: (err: unknown) => string;
    NumberParse: (value: string) => string;
    VersionParse: (value: string) => string;
    SemanticVersionParse: (value: string) => string;
    Initialization: () => string;
    Credentials: () => string;
    StorageInitialization: () => string;
    EventSourceInitialization: () => string;
    FeatureFlagConfigurationNotFound: (featureKey: string) => string;
    FeatureFlagEnvironmentDisabled: (featureKey: string, environment: string) => string;
    FeatureFlagVariableNotFound: (variableKey: string, visitorCode: string) => string;
    FeatureFlagVariationNotFound: (variationKey: string, visitorCode: string) => string;
    FeatureFlagExperimentNotFound: (experimentId: number, visitorCode: string) => string;
    VisitAmount: () => string;
    VisitorCodeMaxLength: () => string;
    VisitorCodeEmpty: () => string;
    StorageWrite: (err: unknown) => string;
    StorageRead: (key: KameleoonStorageKey) => string;
    StorageEmpty: () => string;
    StorageParse: (err: unknown, key: KameleoonStorageKey) => string;
    ClientConfiguration: (err: unknown) => string;
    TargetingCondition: (targetingType: TargetingType) => string;
    AmongValuesCheck: (err: unknown, value: string) => string;
    RangeCheck: (value?: number[] | null) => string;
    RemoteData: (err: unknown) => string;
    MaximumRetriesReached: (err: unknown) => string;
};
