import { IExternalLogger, LogLevel } from '../logging/types';
/**
 * A simple implementation of a logger that prints log messages to the console. This logger
 * implements the {@code IExternalLogger} interface.
 */
export declare class DefaultLogger implements IExternalLogger {
    /**
     * @method log - logs a message at the specified log level.
     *
     * @param {LogLevel} level - the log level
     * @param {string} message - the log message
     */
    log(level: LogLevel, message: string): void;
}
