import { Result } from 'ts-res';
import { KameleoonError } from '../kameleoonError';
import { ConfigurationDataType, JSONType } from '../clientConfiguration';
import { RequesterParamsType, GetVisitorDataResultType, GetVisitorDataParamsType } from './types';
export interface IRequester {
    getClientConfiguration: () => Promise<Result<ConfigurationDataType, KameleoonError>>;
    getRemoteData: (key: string) => Promise<Result<JSONType, KameleoonError>>;
    track: (body: string, isBodyUserAgent: boolean) => Promise<Result<void, void>>;
}
export declare class Requester implements IRequester {
    private externalRequester;
    private urlProvider;
    private packageInfo;
    private trackRetryDelay;
    private useAbortController;
    private timeout;
    constructor({ urlProvider, packageInfo, externalRequester, requestTimeout, trackRetryDelay, useAbortController, }: RequesterParamsType);
    getClientConfiguration(timeStamp?: number): Promise<Result<ConfigurationDataType, KameleoonError>>;
    getRemoteData(key: string): Promise<Result<JSONType, KameleoonError>>;
    getVisitorData({ visitorCode, filters, isMappingIdentifier, }: GetVisitorDataParamsType): Promise<Result<GetVisitorDataResultType, KameleoonError>>;
    track(body: string, isBodyUserAgent: boolean): Promise<Result<void, void>>;
    private sendRequest;
    private logRequestError;
    private parseResponse;
}
