import { GetVisitorDataUrlParamsType, UrlProviderInitializeParamsType } from './types';
export interface IUrlProvider {
    initialize(params: UrlProviderInitializeParamsType): void;
    getClientConfigurationUrl(timeStamp?: number): string;
    getEventSourceUrl(): string;
    getRemoteDataUrl(key: string): string;
    getVisitorDataUrl(params: GetVisitorDataUrlParamsType): string;
    getTrackingUrl(isBodyUserAgent: boolean): string;
    dataApiDomain: string;
}
export declare class UrlProvider implements IUrlProvider {
    private ready;
    private isCustomDomain;
    private domains;
    private siteCode?;
    private environment?;
    private packageInfo?;
    initialize({ domain, siteCode, packageInfo, environment, }: UrlProviderInitializeParamsType): void;
    set dataApiDomain(domain: string);
    getClientConfigurationUrl(timeStamp?: number): string;
    getEventSourceUrl(): string;
    getRemoteDataUrl(key: string): string;
    getVisitorDataUrl({ visitorCode, filters, isMappingIdentifier, }: GetVisitorDataUrlParamsType): string;
    getTrackingUrl(isBodyUserAgent: boolean): string;
    private isInitialized;
    private getDataApiUrl;
    private setDomains;
}
