import { Result } from 'ts-res';
import { KameleoonError } from '../kameleoonError';
import { KameleoonStorageKey } from './constants';
import { IExternalStorage, IStorage, StorageDataType } from './types';
export declare class DataStorage<T extends StorageDataType> implements IStorage<T> {
    private externalStorage;
    private storageKey;
    constructor(externalStorage: IExternalStorage, storageKey: KameleoonStorageKey);
    read(): Result<T, KameleoonError>;
    write(data: T): Result<void, KameleoonError>;
    update(data: Partial<T>): Result<void, KameleoonError>;
}
