import { Result } from 'ts-res';
import { SdkLanguageType } from '../../constants';
import { BrowserType, DeviceType } from '../../kameleoonData';
import { KameleoonError } from '../../kameleoonError';
import { CampaignType, EvaluationDataType, MatchType, MatchTypeTest, MatchTypeVariation, NameMatchType, TargetingType, ValueMatchType, VersionMatchType, VisitorType } from '../../targeting/types';
import { OperatingSystemType } from '../../kameleoonData/types';
import { TimeUnit } from '../../utilities';
export interface ICondition {
    evaluate: (data: EvaluationDataType) => Result<boolean, KameleoonError>;
}
export type ConditionType = ICondition;
export type ConditionDataType = {
    id: number;
    targetingType: TargetingType;
    isInclude: boolean | null;
    weight: number;
    customDataIndex?: string | null;
    pageCount?: number | null;
    value?: string | null;
    valueMatchType?: ValueMatchType | null;
    experiment?: number | null;
    variation?: number | null;
    visitCount?: number | null;
    variationKey?: string | null;
    featureFlagId?: number | null;
    ruleId?: number | null;
    variationMatchType?: MatchTypeVariation | null;
    testMatchType?: MatchTypeTest | null;
    matchType?: MatchType | null;
    device?: DeviceType | null;
    browser?: BrowserType | null;
    os?: OperatingSystemType | null;
    name?: string | null;
    nameMatchType?: NameMatchType | null;
    country?: string | null;
    region?: string | null;
    city?: string | null;
    segmentId?: number | null;
    version?: string | null;
    versionMatchType?: VersionMatchType | null;
    visitorType?: VisitorType | null;
    count?: number | null;
    unitOfTime?: TimeUnit | null;
    title?: string | null;
    url?: string | null;
    goalId?: number | null;
    sdkLanguage?: SdkLanguageType | null;
    visitorCode?: string | null;
    range?: number[] | null;
    lowerBound?: number;
    upperBound?: number;
    keyMomentId?: number;
    campaignType?: CampaignType | null;
    personalizationId?: number | null;
};
