import { KameleoonError } from '../kameleoonError';
import { ConditionDataType } from './conditions/types';
import { NodeValueType, Operator } from './types';
export interface INode {
    readonly value?: NodeValueType;
    readonly left?: INode;
    readonly right?: INode;
    readonly error?: KameleoonError;
}
export declare class Node implements INode {
    private nodeValue?;
    private nodeError?;
    private leftChild?;
    private rightChild?;
    private inverseResult;
    constructor(value: ConditionDataType | Operator, left?: INode, right?: INode);
    get value(): NodeValueType | undefined;
    get error(): KameleoonError | undefined;
    get left(): INode | undefined;
    get right(): INode | undefined;
    get inverse(): boolean;
    private isOperator;
}
