import { Result } from 'ts-res';
import { KameleoonError } from '../kameleoonError';
import { EvaluationDataType, SegmentType, TargetingType } from './types';
interface ITree {
    evaluate: (data: EvaluationDataType) => Result<boolean, KameleoonError>;
    hasTargetingType: (targetingType: TargetingType) => boolean;
}
export declare class Tree implements ITree {
    private tree;
    private error;
    private targetingTypes;
    constructor(segment: SegmentType);
    evaluate(data: EvaluationDataType): Result<boolean, KameleoonError>;
    hasTargetingType(targetingType: TargetingType): boolean;
    private evaluateNode;
    private isLeafNode;
    private isNonLeafNode;
    private buildTree;
    private flattenSegment;
    private convertOperators;
}
export {};
