import { Result } from 'ts-res';
import { IExternalPRNG } from '../utilities';
import { AddDataParametersType, GetTrackingBodyResultType } from './types';
interface IBodyProvider {
    getTrackingBody: (visitorCode: string) => GetTrackingBodyResultType;
    addData: ({ visitorCode, variationData, visitorData, userAgent, isConsentProvided, isMappingIdentifier, }: AddDataParametersType) => Result<void, void>;
}
export declare class BodyProvider implements IBodyProvider {
    private prng;
    private currentSize;
    private resultBody;
    private hasUserAgent;
    private trackingVisitors;
    constructor(prng: IExternalPRNG);
    getTrackingBody(): GetTrackingBodyResultType;
    addData({ visitorCode, variationData, visitorData, userAgent, isConsentProvided, isMappingIdentifier, }: AddDataParametersType): Result<void, void>;
    private getVisitorDataLines;
    private getVariationDataLines;
    private prepareVisitorBody;
    private cleanup;
    private checkSize;
    private addVisitorTrackingLines;
    private getActivityLine;
    private getIdentifier;
}
export {};
