import { DataManager, KameleoonDataType } from '../kameleoonData';
import { Requester } from '../requester';
import { IStorage, TrackingDataType } from '../storage';
import { IExternalPRNG } from '../utilities';
import { VariationConfiguration } from '../variationConfiguration';
import { BaseVariationDataType } from '../variationConfiguration/types';
export type PendingDataType = {
    [visitorCode: string]: {
        visitorData: KameleoonDataType[];
        variationData: BaseVariationDataType[];
    };
};
export type VisitorTrackingDataType = {
    isConsentProvided: boolean;
    userAgent: string | undefined;
    isMappingIdentifier: boolean;
    lines: string[];
};
export type TrackerParametersType = {
    trackingStorage: IStorage<TrackingDataType>;
    trackingInterval: number;
    dataManager: DataManager;
    variationConfiguration: VariationConfiguration;
    requester: Requester;
    prng: IExternalPRNG;
};
export type AddDataParametersType = {
    visitorCode: string;
    userAgent?: string;
    isConsentProvided: boolean;
    variationData: BaseVariationDataType[];
    visitorData: KameleoonDataType[];
    isMappingIdentifier: boolean;
};
export type GetTrackingBodyResultType = {
    body: string;
    hasUserAgent: boolean;
};
export type AddVisitorTrackingLineParametersType = {
    isConsentProvided: boolean;
    isMappingIdentifier: boolean;
    visitorCode: string;
    lines: string[];
    userAgent?: string;
};
