import { Result } from 'ts-res';
import { FeatureVariableType } from '../clientConfiguration';
import { KameleoonError } from '../kameleoonError';
import { FeatureVariableResultType } from '../types';
import { ParseVisitorDataParametersType, ParseVisitorDataResultType } from './types';
export declare class Parser {
    static parseFeatureVariable(variable: FeatureVariableType): Result<FeatureVariableResultType, KameleoonError>;
    static parseVisitorData({ data, filters, visitorCode, dataManager, variationConfiguration, }: ParseVisitorDataParametersType): ParseVisitorDataResultType;
    static parseRegExp(value: string): RegExp;
    static parseSecret(secret: string | null): string;
}
