import { Result } from 'ts-res';
import { KameleoonError } from '../kameleoonError';
import { TrackingCacheItemType } from '../types';
import { CustomData } from '../kameleoonData/customData';
import { KameleoonDataType } from '../kameleoonData/types';
import { CacheManager } from '../cacheManager';
import { VersionMatchType } from '../targeting/types';
import { CheckTargetingParametersType, ManageCacheParametersType, TimeUnit, IExternalPRNG } from './types';
import { VariationByExpositionType } from '../clientConfiguration/types';
export declare class Utilities {
    static getNonce(prng: IExternalPRNG): string;
    static checkTargeting({ segment, visitorCode, targetingData, experimentId, variationConfiguration, clientConfiguration, packageInfo, dataManager, }: CheckTargetingParametersType): Result<boolean, KameleoonError>;
    static convertTimeUnit(time: number, timeUnit: TimeUnit): number;
    static isCustomData(dataItem: KameleoonDataType): dataItem is CustomData;
    static updateCache({ hasJsCssVariables, cacheManager, visitorCode, experimentId, variationId, }: ManageCacheParametersType): void;
    static getTrackingCode(trackingCache: CacheManager<TrackingCacheItemType>, visitorCode: string): string;
    static compareSemVer({ version, compareVersion, operator, }: {
        version: string;
        compareVersion: string;
        operator: VersionMatchType;
    }): Result<boolean, KameleoonError>;
    static getVariationByHash(variationByExposition: VariationByExpositionType[], hash: number): VariationByExpositionType | null;
}
