import { ClientConfiguration, FeatureFlagType, RuleItemType } from '../clientConfiguration';
import { DataManager } from '../kameleoonData';
import { KameleoonVisitorDataType } from '../kameleoonData/types';
import { TrackingStatus } from '../types';
import { ExternalPackageInfoType } from '../sdkInfoTypes';
export type UpdateDataStatusParametersType = {
    visitorCode: string;
    experimentIdList: string[];
    status: TrackingStatus;
};
export type FeatureFlagVariationType = {
    variationKey: string;
    variationId: number | null;
    experimentId: number | null;
    featureFlagId: number;
    featureKey: string;
    rule: RuleItemType | null;
    isTargetedRule: boolean;
};
export type GetVariationParametersType = {
    track?: boolean;
    visitorCode: string;
    visitorIdentifier: string;
    featureFlag: FeatureFlagType;
    targetingData?: KameleoonVisitorDataType;
    withAssignment?: boolean;
    packageInfo: ExternalPackageInfoType;
    clientConfiguration: ClientConfiguration;
    dataManager: DataManager;
};
export type BaseVariationDataType = {
    experimentId: number;
    variationId: number;
    isTargetedRule: boolean;
};
export type SimulatedVariationJson = {
    varId: number | null;
    expId: number;
};
