import { Result } from 'ts-res';
import { SetDataCallbackParametersType } from '../types';
import { KameleoonError } from '../kameleoonError';
import { IVisitorCodeManager } from './types';
import { VariationConfiguration } from "../variationConfiguration";
/**
 * VisitorCodeManager - a class which manages visitor codes using cookies, offering functions to generate, retrieve,
 * and handle these codes while considering user consent.
 **/
export declare class VisitorCodeManager implements IVisitorCodeManager {
    private variationConfiguration?;
    private isConsentRequired;
    private setDataCallback?;
    private getDataCallback?;
    set consentRequired(isRequired: boolean);
    get consentRequired(): boolean;
    set getData(callback: (key: string) => string);
    set setData(callback: (params: SetDataCallbackParametersType) => void);
    get setData(): (params: SetDataCallbackParametersType) => void;
    validateVisitorCode(visitorCode: string): Result<void, KameleoonError>;
    getVisitorCode(defaultVisitorCode?: string): string;
    private processSimulatedVariations;
    private getSimulatedVariations;
    private generateVisitorCode;
    setVariationConfiguration(variationConfiguration: VariationConfiguration): void;
}
