"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.StorageCleanupManager=void 0;var _logging=require("../logging"),_constants=require("./constants");function _defineProperty(a,b,c){return(b=_toPropertyKey(b))in a?Object.defineProperty(a,b,{value:c,enumerable:!0,configurable:!0,writable:!0}):a[b]=c,a}function _toPropertyKey(a){var b=_toPrimitive(a,"string");return"symbol"==typeof b?b:b+""}function _toPrimitive(a,b){if("object"!=typeof a||!a)return a;var c=a[Symbol.toPrimitive];if(void 0!==c){var d=c.call(a,b||"default");if("object"!=typeof d)return d;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===b?String:Number)(a)}class StorageCleanupManager{constructor(a,b){_defineProperty(this,"cleanupInterval",void 0),_defineProperty(this,"externalStorage",void 0),this.externalStorage=a,this.cleanupInterval=b,0<b&&this.initCleanupInterval()}initCleanupInterval(){for(const a of Object.values(_constants.KameleoonStorageKey)){let b=null;try{switch(a){case _constants.KameleoonStorageKey.ForcedFeatureVariation:case _constants.KameleoonStorageKey.ForcedExperimentVariation:case _constants.KameleoonStorageKey.VariationData:case _constants.KameleoonStorageKey.ConsentData:_logging.KameleoonLogger.info`Starting cleanup for ${a} with interval ${this.cleanupInterval}`,b=setInterval(()=>this.cleanupData(a),this.cleanupInterval);break;case _constants.KameleoonStorageKey.ClientData:case _constants.KameleoonStorageKey.TargetingData:case _constants.KameleoonStorageKey.TrackingData:case _constants.KameleoonStorageKey.VisitorCode:case _constants.KameleoonStorageKey.DataInfo:case _constants.KameleoonStorageKey.KameleoonSimulationFFData:break;default:_logging.KameleoonLogger.error`Unknown storage key: ${a} for initCleanupInterval.`}}catch(c){b&&clearInterval(b),_logging.KameleoonLogger.error`Error while starting cleanup for ${a} with interval ${this.cleanupInterval}`}}}cleanupData(a){const b=this.externalStorage.read(a);if(b){const c=Date.now();switch(a){case _constants.KameleoonStorageKey.VariationData:this.cleanupVariationData(b,c);break;case _constants.KameleoonStorageKey.ForcedFeatureVariation:this.cleanupForcedFeatureVariationData(b,c);break;case _constants.KameleoonStorageKey.ForcedExperimentVariation:this.cleanupForcedExperimentVariationData(b,c);break;case _constants.KameleoonStorageKey.ConsentData:this.cleanupConsentData(b,c);break;case _constants.KameleoonStorageKey.ClientData:case _constants.KameleoonStorageKey.TargetingData:case _constants.KameleoonStorageKey.TrackingData:case _constants.KameleoonStorageKey.VisitorCode:case _constants.KameleoonStorageKey.DataInfo:case _constants.KameleoonStorageKey.KameleoonSimulationFFData:break;default:_logging.KameleoonLogger.error`Unknown storage key: ${a} for cleanupData.`}this.externalStorage.write(a,b)}}cleanupConsentData(a,b){for(const[c,d]of Object.entries(a)){if("boolean"==typeof d){a[c]={consent:d,expirationTime:b+this.cleanupInterval};continue}const e=d;"number"==typeof e.expirationTime?e.expirationTime<b&&delete a[c]:e.expirationTime=b+this.cleanupInterval}}cleanupVariationData(a,b){for(const[c,d]of Object.entries(a))this.cleanupObjectValues(d,b),0===Object.keys(a[c]).length&&delete a[c]}cleanupForcedFeatureVariationData(a,b){for(const[c,d]of Object.entries(a))for(const[e,f]of Object.entries(d))this.cleanupObjectValues(f,b),0===Object.keys(a[+c][e]).length&&delete a[+c][e]}cleanupForcedExperimentVariationData(a,b){for(const[c,d]of Object.entries(a))this.cleanupObjectValues(d,b),0===Object.keys(a[c]).length&&delete a[c]}cleanupObjectValues(a,b){for(const[c,d]of Object.entries(a))"number"==typeof d.expirationTime?d.expirationTime<b&&delete a[c]:d.expirationTime=b+this.cleanupInterval}}exports.StorageCleanupManager=StorageCleanupManager;