"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.VisitorCodeManager=void 0;var _tsRes=require("ts-res"),_storage=require("../storage"),_kameleoonError=require("../kameleoonError"),_constants=require("./constants"),_logging=require("../logging");function _defineProperty(a,b,c){return(b=_toPropertyKey(b))in a?Object.defineProperty(a,b,{value:c,enumerable:!0,configurable:!0,writable:!0}):a[b]=c,a}function _toPropertyKey(a){var b=_toPrimitive(a,"string");return"symbol"==typeof b?b:b+""}function _toPrimitive(a,b){if("object"!=typeof a||!a)return a;var c=a[Symbol.toPrimitive];if(void 0!==c){var d=c.call(a,b||"default");if("object"!=typeof d)return d;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===b?String:Number)(a)}class VisitorCodeManager{constructor(){_defineProperty(this,"variationConfiguration",void 0),_defineProperty(this,"isConsentRequired",!1),_defineProperty(this,"setDataCallback",void 0),_defineProperty(this,"getDataCallback",void 0)}set consentRequired(a){this.isConsentRequired=a}get consentRequired(){return this.isConsentRequired}set getData(a){this.getDataCallback=a}set setData(a){this.setDataCallback=a}get setData(){if(this.setDataCallback)return this.setDataCallback;throw new Error("Missing setDataCallback!")}validateVisitorCode(a){return 0===a.length?(0,_tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.VisitorCodeEmpty)):a.length>_constants.VISITOR_CODE_MAX_LENGTH?(0,_tsRes.Err)(new _kameleoonError.KameleoonError(_kameleoonError.KameleoonException.VisitorCodeMaxLength)):(0,_tsRes.Ok)()}getVisitorCode(a){if(_logging.KameleoonLogger.debug`CALL: VisitorCodeManager.getVisitorCode(defaultVisitorCode: ${a})`,!this.getDataCallback||!this.setDataCallback)throw new Error("Missing getDataCallback or setDataCallback methods in getVisitorCode!");let b;const c=this.getDataCallback(_storage.KameleoonStorageKey.VisitorCode);return c&&(b=c),b||(a?(this.validateVisitorCode(a).throw(),b=a,_logging.KameleoonLogger.debug`Used default visitor code: ${b}`):(b=this.generateVisitorCode(),_logging.KameleoonLogger.debug`Generated new visitor code: ${b}`)),this.processSimulatedVariations(b),this.isConsentRequired||this.setDataCallback({visitorCode:b,key:_storage.KameleoonStorageKey.VisitorCode,maxAge:_constants.DEFAULT_MAX_AGE,path:_constants.PATH}),_logging.KameleoonLogger.debug`RETURN: VisitorCodeManager.getVisitorCode(defaultVisitorCode: ${a}) -> (visitorCode: ${b})`,b}processSimulatedVariations(a){if(this.variationConfiguration){const b=this.getSimulatedVariations(a);try{this.variationConfiguration.clearSimulatedVariations(a).throw(),null!==b&&0<b.length&&this.variationConfiguration.updateForcedFeatureVariations(a,b).throw()}catch(a){a instanceof Error&&_logging.KameleoonLogger.error`Failed to process simulated variations: ${a.message}`}}}getSimulatedVariations(a){_logging.KameleoonLogger.debug`CALL: VisitorCodeManager.getSimulatedVariations(visitorCode: ${a})`;const b=this.getDataCallback(_storage.KameleoonStorageKey.KameleoonSimulationFFData);let c=null;if("string"==typeof b&&0<b.length)try{const a=JSON.parse(decodeURIComponent(b));a&&"object"==typeof a&&(c=Object.entries(a).map(a=>{let[b,c]=a;return this.variationConfiguration.simulatedVariationFromJson(b,c)}).filter(a=>null!==a))}catch(a){a instanceof Error&&_logging.KameleoonLogger.error`Failed to parse simulated variations: ${a.message}`}return _logging.KameleoonLogger.debug`RETURN: VisitorCodeManager.getSimulatedVariations(visitorCode: ${a}) -> (variations: ${c})`,c}generateVisitorCode(){const a="abcdefghijklmnopqrstuvwxyz0123456789",b=[];for(let c=0;c<_constants.VISITOR_CODE_LENGTH;c++)b.push(a[Math.floor(Math.random()*a.length)]);return b.join("")}setVariationConfiguration(a){this.variationConfiguration||(this.variationConfiguration=a)}}exports.VisitorCodeManager=VisitorCodeManager;